import pygame
import vector2

class GameSprite(pygame.sprite.Sprite):
    def __init__(self,x=0,y=0,width=48,height=48,world=0):
        pygame.sprite.Sprite.__init__(self)
        self.world=world
        self.rect=pygame.Rect((0,0),(width,height))
        self.rect.bottomleft=(x,y+height)
        self.bbox=pygame.Rect(self.rect)
        self.loadsprites()
        self.action="stand"
        if world ==0: print "error"
        #self.worldPos=vector2.Vector2(x,y)
        #self.screenPos=vector2.Vector2(x,y)
        self.worldPos=vector2.Vector2(self.rect.left,self.rect.bottom)
        self.screenPos=self.worldPos.copy()
        self.speed=vector2.Vector2()
        debug=0

    def loadsprites(self):
        self.currentFrame=pygame.Surface((self.rect.width,self.rect.height))
        self.currentFrame.fill((0,0,0))

    def fill(self,tile):
        self.currentFrame=pygame.Surface((self.rect.width,self.rect.height))
        if not(tile):
            self.currentFrame.fill((0,0,0))
        else:
            for y in range(0,self.rect.height,tile.get_height()):
                for x in range(0,self.rect.width,tile.get_width()):
                    self.currentFrame.blit(tile,(x,y))

    def displayFrame(self):
        return self.currentFrame

    def setAction(self,action,parameters=[]):
        self.action=action
        if self.action == "stand":
            self.speed=vector2.Vector2(0,0)

    def act(self):
        pass

    def move(self):
        self.screenPos=self.worldPos-self.world.mapDraw
        if self.debug: print self.screenPos,self.worldPos,self.world.mapDraw
        self.rect.left=int(self.screenPos.x+self.world.offsety)
        self.rect.top=int(self.screenPos.y+self.world.offsety)
        if self.debug: print "move",self.rect.left,self.rect.top,self.screenPos,self.world.factorH,self.world.factorV,self.world.offset
