import sys
import pygame
from pygame.locals import *

#import gamesprite
#import roles
#import world
#import vector2
import scenemanager
import menumanager
import userevent

class Game:
    def __init__(self, width=1024,height=768,fs=0,debug=0):
        pygame.init()

        #self.config()

        self.width = width
        self.height = height

        if fs == 1: self.screen = pygame.display.set_mode((self.width,self.height),FULLSCREEN)
        else: self.screen = pygame.display.set_mode((self.width,self.height))
        #self.scrRect = self.screen.get_rect( )

        self.clock = pygame.time.Clock()

        self.setDebugMode(debug)
        
        #self.spriteList = []
        self.sceneManager=scenemanager.SceneManager(self.screen)
        self.menuManager=menumanager.MenuManager(self.screen)

    def config(self):
        infile=open('lab.cfg','r')
        for line in infile.readlines():
            print line
        infile.close()

    def setDebugMode(self,debug):
        self.debug = debug

    def run(self):
        while True:
            self.sceneManager.drawScene()
            if self.sceneManager.paused:
                self.menuManager.refresh()
            pygame.display.flip()
            for event in pygame.event.get():
                #print event,userevent.PAUSE
                if event.type == pygame.QUIT: 
                    sys.exit()
                elif event == userevent.PAUSE:
                    #print 'pause'
                    self.sceneManager.pause()
                    self.menuManager.openMenu('pause')
                    #pygame.display.flip()
                elif event == userevent.RESUME:
                    #print 'resume'
                    self.menuManager.closeMenu()
                    self.sceneManager.resume()
                else:
                    if self.sceneManager.paused:
                        self.menuManager.sendEvent(event)
                    else: self.sceneManager.sendEvent(event)
            self.clock.tick(30)
            
if __name__ == "__main__":
    game=Game(1024,768,0)
    #game=Game(800,600,0)
    game.run()
