import sys
import pygame
from pygame.locals import *
import actor
import userevent
import ui

class SceneManager:
    def __init__(self,screen):
        self.screen=screen
        self.scrRect=self.screen.get_rect()
        self.paused=False
        self.background=pygame.Surface((self.scrRect.width,self.scrRect.height))
        self.actors=pygame.sprite.RenderUpdates()
        self.ui=pygame.sprite.RenderUpdates()
        self.contextMenu=ui.ContextMenu([''])
        self.i=0
        self.loadScene(1)
        self.currentDialog=0
        self.currentLine=0
        self.playingDialog=False
        
        
    def sendEvent(self,event):
        if event.type == MOUSEBUTTONDOWN:
            #print event.pos
            shouldMove=True
            if event.button==1:
                if self.playingDialog:
                    shouldMove=False
                    self.playNextLine()
                if self.contextMenu.opened:
                    self.closeContextMenu()
                    if self.contextMenu.rect.collidepoint(event.pos):
                        shouldMove=False
                        action=self.contextMenu.clicked(event.pos)
                        if action == 'Parler':
                            if self.contextMenu.referer==self.second:
                                self.playDialog(1)
                for actor in self.actors:
                    if actor.rect.collidepoint(event.pos):
                        shouldMove=False
                        actions=actor.listActions(self.mainactor.rect.midbottom[0]-actor.rect.midbottom[0],self.mainactor.rect.midbottom[1]-actor.rect.midbottom[1])
                        if actions!=[]:
                            #print actions
                            self.openContextMenu(actor.rect.topright,actions,actor)
                if shouldMove:
                    self.mainactor.moveto(event.pos)
            #eli
        elif event.type == KEYDOWN:
            #print 'keydown',event.key, K_ESCAPE
            if (event.key == K_ESCAPE):
                #print 'should pause'
                #print userevent.PAUSE
                pygame.event.post(userevent.PAUSE)

    def pause(self):
        self.paused=True

    def resume(self):
        self.paused=False

    def openContextMenu(self,pos,elts,actor):
        if self.contextMenu.opened: self.closeContextMenu()
        self.contextMenu=ui.ContextMenu(elts)
        self.contextMenu.rect.topleft=pos
        self.contextMenu.opened=True
        self.contextMenu.referer=actor
        self.ui.add(self.contextMenu)

    def closeContextMenu(self):
        self.contextMenu.kill()
        self.contextMenu.opened=False

    def playDialog(self,id):
        print 'Playing dialog',id
        self.currentDialog=id
        self.currentLine=0
        self.playingDialog=True
        self.playNextLine()

    def playNextLine(self):
        self.currentLine=self.currentLine+1
        if self.currentDialog==1:
            if self.currentLine==1:
                self.ui.clear(self.screen,self.background)
                self.ui.add(self.mainactor.say('Blabla'))
            elif self.currentLine==2:
                self.ui.clear(self.screen,self.background)
                self.ui.add(self.second.say('Snif'))
            elif self.currentLine==3:
                self.endScene(1)
                sys.exit()

    def loadScene(self,scene):
        #self.background.fill((255,255,255))
        self.background.blit(pygame.image.load('images/pont de l amoureux-1024x768.png').convert_alpha(),(0,0))
        self.screen.blit(self.background,(0,0))
        
        self.mainactor=actor.Actor(290,685,84,176,'Philippe')
        self.mainactor.image=pygame.Surface((68,143),pygame.SRCALPHA,32)
        (self.mainactor.rect.width,self.mainactor.rect.height)=(68,143)
        pygame.transform.scale(pygame.image.load('images/pont de l amoureux-philippe.png').convert_alpha(),(68,143),self.mainactor.image)
        self.mainactor.actions=[]
        self.actors.add(self.mainactor)
        
        self.second=actor.Actor(500,500,68,219,'Inconnu')
        self.second.image=pygame.Surface((40,129),pygame.SRCALPHA,32)
        (self.second.rect.width,self.second.rect.height)=(40,129)
        pygame.transform.scale(pygame.image.load('images/pont de l amoureux-amoureux.png').convert_alpha(),(40,129),self.second.image)
        self.second.moveto((500,424))
        self.second.actions=['Parler']
        self.actors.add(self.second)
        #pygame.display.flip()

    def drawScene(self):
        self.screen.blit(self.background,(0,0))
        #self.actors.clear(self.screen,self.background)
        changesActor=self.actors.draw(self.screen)
        changesUI=self.ui.draw(self.screen)
        #pygame.display.update(changes)
        pass

    def endScene(self,id):
        print 'end'
